//This is a program that demonstrates the use of software LCD control with
//Microchips Libraries.It simply displays "Hello World!" 
//The External LCD Section is documented on P#79 of C18 Libraries
//Use 181320LCD.DSN
//Replace this xlcd.h in the MCC18>h folder.
//Add all files in the folder in your projec.Also present in MCC18 isntallation folder.
//Pin changes have been made in the provided xlcd.h file.

#include<p18f1320.h>// Include files and definitions for the Processor
#include<xlcd.h>// Include function definitions for the External LCD Library library
#include<delays.h>// Include function definitions for built in Delay routines
#pragma config LVP=OFF,OSC=INTIO2,WDT=OFF// Use internal Oscillator, Watchdog off, LVP off
void main(void)
{
	unsigned char data[]="Hello World!";
    unsigned char newlineadd=0x40;
	OSCCON=0x60;//Internal 4MHZ Oscillator
	ADCON1=0X7F;//Make all ports Digital	
	OpenXLCD( EIGHT_BIT & LINES_5X7 );// Use 8 bit Data, 5x7 pixel Matrix per character
	while( BusyXLCD());// Wait till LCD finishes executing command
	WriteCmdXLCD( CURSOR_ON);// Turn cursor ON
	while( BusyXLCD() );// Wait till LCD finishes executing command
	WriteCmdXLCD( SHIFT_DISP_LEFT );//Shift Cursor Display Left
	while( BusyXLCD());// Wait till LCD finishes executing command
	putsXLCD(data);// Write the String data to the LCD
	while( BusyXLCD() );
    SetDDRamAddr( newlineadd );
	while( BusyXLCD() );
	putcXLCD(0x40);// Write the String data to the LCD
	while(1);// Wait here
}


// As indicated in the C18 libraries manual
// These delays are required for LCD operation

/****************************************************************/
//  DelayFor18TCY  =18 cycles.
/****************************************************************/

void DelayFor18TCY(void)
{
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
_asm NOP _endasm
}


/****************************************************************/
//  DelayPORXLCD  =15 ms.
/****************************************************************/

void DelayPORXLCD(void)
{
Delay1KTCYx(15);
}

/****************************************************************/
//  DelayXLCD  =5 ms.
/****************************************************************/

void DelayXLCD(void)
{
Delay1KTCYx(5);
}

